﻿﻿﻿<?php

class osC_Payment_iccard extends osC_Payment
{

	var $_title, $_code = 'iccard', $_status = false, $_sort_order, $_order_id;

	function osC_Payment_iccard()
	{
		global $osC_Database, $osC_Language, $osC_ShoppingCart;
		$this->_title = $osC_Language->get('payment_iccard_title');
		$this->_method_title = $osC_Language->get('payment_iccard_method_title');
		$this->_status = (MODULE_PAYMENT_ICCARD_STATUS == '1') ? true : false;
		$this->_sort_order = MODULE_PAYMENT_ICCARD_SORT_ORDER;
		$this->form_action_url = 'https://service.iccard.ir/internetpaymentgateway/pay/';
		if ($this->_status === true)
		{
			if ((int)MODULE_PAYMENT_ICCARD_ORDER_STATUS_ID > 0)
			{
				$this->order_status = MODULE_PAYMENT_ICCARD_ORDER_STATUS_ID;
			}
			if ((int)MODULE_PAYMENT_ICCARD_ZONE > 0)
			{
				$check_flag = false;
				$Qcheck = $osC_Database->query('select zone_id from :table_zones_to_geo_zones where geo_zone_id = :geo_zone_id and zone_country_id = :zone_country_id order by zone_id');
				$Qcheck->bindTable(':table_zones_to_geo_zones', TABLE_ZONES_TO_GEO_ZONES);
				$Qcheck->bindInt(':geo_zone_id', MODULE_PAYMENT_ICCARD_ZONE);
				$Qcheck->bindInt(':zone_country_id', $osC_ShoppingCart->getBillingAddress('country_id'));
				$Qcheck->execute();
				while ($Qcheck->next())
				{
					if ($Qcheck->valueInt('zone_id') < 1)
					{
						$check_flag = true;
						break;
					}
					elseif ($Qcheck->valueInt('zone_id') == $osC_ShoppingCart->getBillingAddress('zone_id'))
					{
						$check_flag = true;
						break;
					}
				}
				if ($check_flag === false)
				{
					$this->_status = false;
				}
			}
		}
	}

	function selection()
	{
		return array('id' => $this->_code, 'module' => $this->_method_title);
	}

	function confirmation()
	{
		$this->_order_id = osC_Order::insert(ORDERS_STATUS_PREPARING);
	}


	function process_button()
	{
		global $osC_Currencies, $osC_ShoppingCart, $osC_Language, $osC_Database;
		if (MODULE_PAYMENT_ICCARD_CURRENCY == 'Selected Currency')
		{
			$currency = $osC_Currencies->getCode();
		}
		else
		{
			$currency = MODULE_PAYMENT_ICCARD_CURRENCY;
		}
		$user = new osC_Customer();
		$amount = round($osC_Currencies->formatRaw($osC_ShoppingCart->getTotal(), $currency), 2);
		$callback = osc_href_link(FILENAME_CHECKOUT, 'process', 'SSL', null, null, true);
		require_once(DIR_FS_CATALOG . '/ext/iccard/iccard_payment_helper.class.php');
		$i = new ICCard_Payment_Helper(MODULE_PAYMENT_ICCARD_TERMINAL);
		$r = $i->paymentRequest(array(
				'amount'   => intval(ceil($amount)),
				'order_id' => $this->_order_id,
				'callback' => $callback
			));
		if ($r)
		{
			$osC_Database->simpleQuery("insert into `" . DB_TABLE_PREFIX . "iccard_transactions` (orders_id,receipt_id,transaction_method,transaction_date,transaction_amount,transaction_id) values ('{$this->_order_id}','{$r}','iccard','','$amount','')");
			return osc_draw_hidden_field('token', $i->token);
		}
		else
		{
			osC_Order::remove($this->_order_id);
			echo '<div style="font-size:11px; color:#cc0000; width:500; border:1px solid #cc0000; padding:5px; background:#ffffcc;">' . $i->error . '</div>';
		}
	}

	function get_error()
	{
		global $osC_Language;
		return $error;
	}
	function process()
	{
		global $osC_Language, $osC_Customer, $osC_Currencies, $osC_ShoppingCart, $_POST, $_GET, $messageStack, $osC_Database;
		$this->_order_id = osC_Order::insert(ORDERS_STATUS_PREPARING);
		if (MODULE_PAYMENT_ICCARD_CURRENCY == 'Selected Currency')
		{
			$currency = $osC_Currencies->getCode();
		}
		else
		{
			$currency = MODULE_PAYMENT_ICCARD_CURRENCY;
		}
		$OrderId = $_POST['invoiceid'];
		require_once(DIR_FS_CATALOG . '/ext/iccard/iccard_payment_helper.class.php');
		$i = new ICCard_Payment_Helper(MODULE_PAYMENT_ICCARD_TERMINAL);
		$r = $i->paymentVerify($_POST);
		if ($r)
		{
			$osC_Database->simpleQuery("update `" . DB_TABLE_PREFIX . "iccard_transactions` set receipt_id = '{$_POST[ref]}', transaction_id = '{$_POST[ref]}', transaction_date = '" . date("YmdHis") . "' where orders_id = '{$OrderId}' ");
			$Qtransaction = $osC_Database->query('insert into :table_orders_transactions_history (orders_id, transaction_code, transaction_return_value, transaction_return_status, date_added) values (:orders_id, :transaction_code, :transaction_return_value, :transaction_return_status, now())');
			$Qtransaction->bindTable(':table_orders_transactions_history', TABLE_ORDERS_TRANSACTIONS_HISTORY);
			$Qtransaction->bindInt(':orders_id', $this->_order_id);
			$Qtransaction->bindInt(':transaction_code', 1);
			$Qtransaction->bindValue(':transaction_return_value', $_POST['ref']);
			$Qtransaction->bindInt(':transaction_return_status', 1);
			$Qtransaction->execute();
			$this->_order_id = osC_Order::insert();
			$comments = $osC_Language->get('payment_iccard_method_txn_id') . '[' . $_POST['ref'] . ']';
			osC_Order::process($this->_order_id, $this->order_status, $comments);
		}
		else
		{
			$osC_Database->simpleQuery("delete from `" . DB_TABLE_PREFIX . "iccard_transactions` where receipt_id = '{$OrderId}' and orders_id = '{$this->_order_id}' ");
			osC_Order::remove($this->_order_id);
			$messageStack->add_session('checkout', $osC_Language->get('payment_iccard_result_error'), 'error');
			$messageStack->add_session('checkout', $i->error, 'error');
			osc_redirect(osc_href_link(FILENAME_CHECKOUT, 'checkout&view=paymentInformationForm', 'SSL', null, null, true));
		}
	}

	function callback()
	{
		global $osC_Database;
	}

}

?>